// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.

#ifndef EVALCORR_H2
#define EVALCORR_H2

#include <cstdio>
#include <string>
#include <sstream>
#include <map>
#include <cmath>

#include "param.h"
#include "errstr.h"
#include "Dal.h"
#include "stringutil.h"


#include <Tracer.h>
#include <errstr.h>

typedef std::vector<std::string> strlist;

typedef map<string,double> Attmap;
typedef pair<string,double> Attype;
typedef map<string,bool> Testmap;
typedef pair<string,string> Testtype;

/* Utilities */
void readkeywords( Table* , Attmap& );
void copycols( Table* );
void writeattribute( Table* , const string& , const double , const string& );
void writeattribute( Table* , const string& , const bool , const string& );
void writeattribute( Table* , const string& , const string& , const string& );
void writeposcorok( Table* , const bool );
void writesyserrcc( Table* , const double );
void writelikhdcmp( Table* , const double );
/* Tests */
bool test1xmm( Attmap& , const double , const double );
bool test2xmm( Attmap& , const double , const double , double& );

#endif
